// to represent an nonempty list of image files
public class ConsLoIF implements LoIF {
  public ImageFile first;
  public LoIF rest;
  
  public ConsLoIF(ImageFile first, LoIF rest) {
    this.first = first;
    this.rest = rest;
  }
  

  // is this nonempty list same as the given object?
  public boolean same(Object obj){
    if (obj instanceof ConsLoIF)
      return this.sameConsLoIF((ConsLoIF) obj);
    else
      return false;
  }
  
  // is this nonempty list same as the given nonempty list?
  public boolean sameConsLoIF(ConsLoIF that){
    return this.first.same(that.first) &&
           this.rest.same(that.rest);
  }
  
  // represent this data as String
  public String toString(){
    return "new ConsLoIF(\n" +
           "   this.first = " + this.first + ",\n" +
           "   this.rest = " + this.rest + ")\n";
  }

}