public class ImageFile implements ISame{
  public String name;
  public int width;
  public int height;
  public String kind;
  
  public ImageFile(String name, int width, int height, String kind){
    this.name = name;
    this.width = width;
    this.height = height;
    this.kind = kind;
  }

  /* TEMPLATE:
  ... this.name ...
  ... this.name   = ??? 
  ... this.width ...
  ... this.width  =  ???
  ... this.height ...
  ... this.height = ???
  ... this.kind ... 
  ... this.kind   = ???
  */

  // crop this imagefile to the given width and height
  // EFFECT: the width and height change to the given values
  public void crop(int w, int h){
    this.width = w;
    this.height = h;
  }
  
  // change the name of this imagefile to the given name
  // EFFECT: the name will change to the given value
  public void changeName(String name){
    this.name = name;
  }
  
  // is this imagefile the same as the given one?
  public boolean same(Object obj){
    if (obj instanceof ImageFile)
      return this.sameImageFile((ImageFile)obj);
    else
      return false;
  }
  
  // is this imagefile the same as the given one?
  public boolean sameImageFile(ImageFile that){
    return this.name.equals(that.name) &&
           this.width == that.width &&
           this.height == that.height &&
           this.kind.equals(that.kind);
  }
  
  // represent this data as String
  public String toString(){
    return "new ImageFile(\n" +
           "   this.name = " + this.name + ",\n" +
           "   this.width = " + this.width + ",\n" +
           "   this.height = " + this.height + ",\n" +
           "   this.kind = " + this.kind + ")\n";
  }

}